## mingw-w64-quantum-espresso-7.4.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)
# CMake < 3.13 cannot install external targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2152

# CMake < 3.14 generates incorrect dependency graphs with
# alias targets:
# https://gitlab.kitware.com/cmake/cmake/merge_requests/2521

# CMake < 3.20 does not support NVHPC compiler id
# https://cmake.org/cmake/help/latest/release/3.20.html#compilers

# Policy CMP0048: The project() command manages VERSION variables
set(CMAKE_POLICY_DEFAULT_CMP0048 NEW)

project(qe
    VERSION 7.4.1
    DESCRIPTION "ESPRESSO: opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization"
    LANGUAGES Fortran C)

if(${qe_BINARY_DIR} STREQUAL ${qe_SOURCE_DIR})
    message(FATAL_ERROR "QE source folder cannot be safely used as a build folder!")
endif()

##########################################################
# Define the paths for static libraries and executables
##########################################################
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/lib 
    CACHE
    PATH "Single output directory for building all libraries.")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${qe_BINARY_DIR}/bin 
    CACHE
    PATH "Single output directory for building all executables.")

###########################################################
# Build helpers
###########################################################
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include(cmake/qeHelpers.cmake)

###########################################################
# Build Type
# Ensure that a specific, default build type is set when
# none has been explicitly set by the user
###########################################################
qe_ensure_build_type("Release")

###########################################################
# Modules
###########################################################
include(CheckFunctionExists)
# Must use GNUInstallDirs to install libraries into correct
# locations on all platforms.
include(GNUInstallDirs)

###########################################################
# Build Options
###########################################################
include(CMakeDependentOption)
option(QE_ENABLE_CUDA
    "enable CUDA acceleration on NVIDIA GPUs" OFF)
if(QE_ENABLE_CUDA)
    option(QE_ENABLE_OPENACC "enable OpenACC acceleration" ON)
    # OpenMP enabled by default if CUDA is enable
    option(QE_ENABLE_OPENMP
        "enable distributed execution support via OpenMP" ON)
else()
    option(QE_ENABLE_OPENACC "enable OpenACC acceleration" OFF)
    option(QE_ENABLE_OPENMP
        "enable distributed execution support via OpenMP" OFF)
endif()
cmake_dependent_option(QE_ENABLE_OFFLOAD
    "enable OpenMP offload"
    OFF "QE_ENABLE_OPENMP" OFF)
option(QE_ENABLE_MPI
    "enable distributed execution support via MPI" ON)
option(QE_ENABLE_MPI_GPU_AWARE
    "enable GPU aware MPI operations" OFF)
option(QE_ENABLE_TEST
    "enable unit and system tests" ON)
cmake_dependent_option(QE_ENABLE_BENCHMARK
    "enable benchmark tests" OFF "QE_ENABLE_TEST" OFF)
option(QE_ENABLE_TRACE
    "enable execution tracing output" OFF)
option(QE_ENABLE_PROFILE_NVTX
        "enable execution of NVIDIA NVTX profiler plugin" OFF)
option(QE_ENABLE_MPI_INPLACE
    "enable inplace MPI calls (ignored when QE_ENABLE_MPI=OFF)" OFF)
option(QE_ENABLE_BARRIER
    "enable global synchronization between execution units" OFF)
option(QE_LAPACK_INTERNAL
    "enable internal reference LAPACK" OFF)
option(QE_ENABLE_SCALAPACK
    "enable SCALAPACK execution units" OFF)
cmake_dependent_option(QE_ENABLE_SCALAPACK_QRCP
    "enable SCALAPACK QRCP in pw2wannier90 (requires SCALAPACK>=2.1.0 or Intel MKL>=2020)"
    OFF "QE_ENABLE_SCALAPACK" OFF)
option(QE_ENABLE_ELPA
    "enable ELPA execution units" OFF)
option(QE_ENABLE_LIBXC
    "enable LIBXC execution units" OFF)
option(QE_ENABLE_HDF5
    "enable HDF5 data collection" OFF)
option(QE_ENABLE_STATIC_BUILD
    "enable fully static build of executables" OFF)
option(QE_ENABLE_DOC
    "enable documentation building" OFF)
option(QE_CLOCK_SECONDS
    "print program time in seconds" OFF)
set(QE_FFTW_VENDOR "AUTO" CACHE
    STRING "select a specific FFTW library [Intel_DFTI, Intel_FFTW3, ArmPL, IBMESSL, FFTW3, Internal]")
set(QE_ENABLE_SANITIZER "none" CACHE STRING "none,asan,ubsan,tsan,msan")
set(QE_ENABLE_PLUGINS "" CACHE STRING "Semicolon-separated list of plugins")
set (QE_EXTRA_DEFINITIONS "" CACHE STRING "Semicolon-separated list of extra global definitions")
option(QE_ENABLE_FOX
    "enable XML I/O via Fox library" OFF)
if(QE_ENABLE_FOX)
    if(FOX_ROOT)
        set(QE_FOX_INTERNAL OFF)
    endif()
    option(QE_FOX_INTERNAL
        "enable FoX internal library" ON)
endif()

if(WANNIER90_ROOT)
    set(QE_WANNIER90_INTERNAL OFF)
endif()
option(QE_WANNIER90_INTERNAL
    "enable Wannier90 internal library" ON)
if(MBD_ROOT)
    set(QE_MBD_INTERNAL OFF)
endif()
option(QE_MBD_INTERNAL
    "enable LibMBD internal library" ON)
if(DEVICEXLIB_ROOT)
    set(QE_DEVICEXLIB_INTERNAL OFF)
endif()
option(QE_DEVICEXLIB_INTERNAL
    "enable DeviceXlib internal library" ON)
if(ENVIRON_ROOT)
    set(ENVIRON_DEFAULT "EXTERNAL")
else()
    set(ENVIRON_DEFAULT "NO")
endif()
set(QE_ENABLE_ENVIRON "${ENVIRON_DEFAULT}" CACHE
    STRING "select a specific Environ library [NO, EXTERNAL, INTERNAL]")

# OSCDFT
option(QE_ENABLE_OSCDFT "enable OS-CDFT 10.1021/acs.jctc.9b00281" OFF)


# TODO change all ifdefs throughout code base to match
# cmake options
# TODO symbols beginning with '__' followed by a capital
# character are reserved for standard library use (at
# least in C, not sure about Fortran), change all feature
# macros to avoid weird behaviors

if(QE_ENABLE_CUDA)
    qe_add_global_compile_definitions(__CUDA)
endif()
if(QE_ENABLE_TRACE)
    qe_add_global_compile_definitions(__TRACE)
endif()
if(QE_ENABLE_PROFILE_NVTX)
   qe_add_global_compile_definitions(__PROFILE_NVTX) 
endif() 
if(QE_ENABLE_MPI_INPLACE)
    qe_add_global_compile_definitions(__USE_INPLACE_MPI)
endif()
if(QE_ENABLE_BARRIER)
    qe_add_global_compile_definitions(__USE_BARRIER)
endif()
foreach(DEF IN LISTS QE_EXTRA_DEFINITIONS)
    qe_add_global_compile_definitions(${DEF})
endforeach()
if(QE_ENABLE_MPI)
    # OMPI_SKIP_MPICXX: skip CXX APIs on openmpi, cause trouble to C APIs
    qe_add_global_compile_definitions(__MPI OMPI_SKIP_MPICXX)
    if(QE_ENABLE_MPI_GPU_AWARE)
        qe_add_global_compile_definitions(__GPU_MPI)
    endif()
endif()
if(QE_ENABLE_SCALAPACK)
    qe_add_global_compile_definitions(__SCALAPACK)
endif()
if(QE_ENABLE_HDF5)
    qe_add_global_compile_definitions(__HDF5)
endif()
if(QE_ENABLE_ENVIRON)
    qe_add_global_compile_definitions(__ENVIRON)
endif()
if(QE_CLOCK_SECONDS)
   qe_add_global_compile_definitions(__CLOCK_SECONDS)
endif()

# OSCDFT
if(QE_ENABLE_OSCDFT)
    qe_add_global_compile_definitions(__OSCDFT)
endif()

# Check options consistency
if(QE_ENABLE_STATIC_BUILD AND BUILD_SHARED_LIBS)
    message(FATAL_ERROR "Full static build of QE executables requires static QE internal libraries. QE_ENABLE_STATIC_BUILD and BUILD_SHARED_LIBS cannot be both ON")
endif()
if(QE_ENABLE_ELPA AND NOT QE_ENABLE_SCALAPACK)
    message(FATAL_ERROR "ELPA requires SCALAPACK support, enable it with '-DQE_ENABLE_SCALAPACK=ON' or disable ELPA with '-DQE_ENABLE_ELPA=OFF'")
endif()
if(QE_ENABLE_SCALAPACK AND NOT QE_ENABLE_MPI)
    message(FATAL_ERROR "SCALAPACK requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable SCALAPACK with '-DQE_ENABLE_SCALAPACK=OFF'")
endif()
if(QE_ENABLE_CUDA AND NOT (CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"))
    message(FATAL_ERROR "NVHPC compiler is mandatory when CUDA is enabled due QE is based on CUDA Fortran language")
endif()
if(QE_ENABLE_OPENACC AND NOT (CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"))
    message(FATAL_ERROR "NVHPC compiler is mandatory when OpenACC is enabled")
endif()
if(QE_ENABLE_MPI_GPU_AWARE AND NOT (QE_ENABLE_CUDA AND QE_ENABLE_MPI))
    message(FATAL_ERROR "GPU aware MPI requires both MPI and CUDA features enabled")
endif()
# if(QE_ENABLE_HDF5 AND NOT QE_ENABLE_MPI)
#    message(FATAL_ERROR "HDF5 requires MPI support, enable it with '-DQE_ENABLE_MPI=ON' or disable HDF5 with '-DQE_ENABLE_HDF5=OFF'")
# endif()

# Add optional sanitizers ASAN, UBSAN, MSAN
set(VALID_SANITIZERS "none" "asan" "ubsan" "tsan" "msan")
# Perform sanitizer option check, only works in debug mode
if(NOT QE_ENABLE_SANITIZER IN_LIST VALID_SANITIZERS)
  message(FATAL_ERROR "Invalid -DQE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER}, value must be one of ${VALID_SANITIZERS}")
else()
  message(STATUS "Enable sanitizer QE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER}")
endif()
# only GNU works right now
if(NOT QE_ENABLE_SANITIZER STREQUAL "none" AND NOT CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  message(FATAL_ERROR "-DQE_ENABLE_SANITIZER=${QE_ENABLE_SANITIZER} only works with the GNU compiler")
endif()

# valid plugins checks
set(VALID_QE_PLUGINS "d3q" "pw2qmcpack" "gipaw" "legacy")
# Perform sanitizer option check, only works in debug mode
foreach(PLUGIN IN LISTS QE_ENABLE_PLUGINS)
  if(NOT PLUGIN IN_LIST VALID_QE_PLUGINS)
    message(FATAL_ERROR "Invalid QE plugin ${PLUGIN}, value must be one of \"${VALID_QE_PLUGINS}\".")
  else()
    message(STATUS "Enable QE plugin ${PLUGIN}")
  endif()
endforeach()

############################################################
# C preprocessor
# Note: reply on the compiler preprocessor whenever possible
############################################################
if(DEFINED ENV{CPP})
    set(QE_CPP_DEFAULT $ENV{CPP})
else()
    set(QE_CPP_DEFAULT cpp)
endif()
# QE_CPP_DEFAULT is only effective when cached QE_CPP doesn't exist.
set(QE_CPP ${QE_CPP_DEFAULT} CACHE
    STRING "C preprocessor for qe_preprocess_source in qeHelpers.cmake")
find_program(QE_CPP_FULL_PATH NAMES ${QE_CPP} DOC "C preprocessor full path")
if(QE_CPP_FULL_PATH)
    message(STATUS "C preprocessor used by qe_preprocess_source in qeHelpers.cmake: ${QE_CPP_FULL_PATH}")
else()
    set(QE_CPP_SAVED ${QE_CPP})
    unset(QE_CPP CACHE)
    message(FATAL_ERROR "C preprocessor ${QE_CPP_SAVED} not found. Pass a working one to CMake via QE_CPP!")
endif()

###########################################################
# language standard requirements
###########################################################
# TODO need to require all compilers using the same one
if(CMAKE_Fortran_COMPILER_ID MATCHES "PGI" OR CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC")
    set(CMAKE_C_STANDARD 11)
    set(CMAKE_C_STANDARD_REQUIRED ON)
    set(CMAKE_C_EXTENSIONS OFF)
endif()

###########################################################
# check Fortran compiler -isystem option support
###########################################################
include(CheckFortranCompilerFlag)
check_fortran_compiler_flag("-isystem ." Fortran_ISYSTEM_SUPPORTED)
if(NOT Fortran_ISYSTEM_SUPPORTED AND NOT DEFINED CMAKE_NO_SYSTEM_FROM_IMPORTED)
  set(CMAKE_NO_SYSTEM_FROM_IMPORTED ON)
endif()

###########################################################
# OpenMP
# The following targets will be defined:
add_library(qe_openmp_fortran INTERFACE)
qe_install_targets(qe_openmp_fortran)
###########################################################
if(QE_ENABLE_OPENMP)
    find_package(OpenMP REQUIRED Fortran)
    target_link_libraries(qe_openmp_fortran INTERFACE OpenMP::OpenMP_Fortran)
endif(QE_ENABLE_OPENMP)
if(QE_ENABLE_OFFLOAD)
    target_compile_definitions(qe_openmp_fortran INTERFACE "$<$<COMPILE_LANGUAGE:Fortran>:__OPENMP_GPU>")
endif()

###########################################################
# OpenACC
# The following targets will be defined:
add_library(qe_openacc_fortran INTERFACE)
add_library(qe_openacc_c INTERFACE)
qe_install_targets(qe_openacc_fortran qe_openacc_c)
###########################################################

=== Doc/Makefile ===
LATEX   = pdflatex
LATEX2HTML = latex2html

PDFS = constraints_HOWTO.pdf  user_guide.pdf brillouin_zones.pdf Hubbard_input.pdf 
AUXS = $(PDFS:.pdf=.aux)
LOGS = $(PDFS:.pdf=.log)
OUTS = $(PDFS:.pdf=.out)
TOCS = $(PDFS:.pdf=.toc)

all:  pdf html
pdf:  $(PDFS)
html: user_guide

$(PDFS): %.pdf: %.tex
	$(LATEX)  $<
	$(LATEX)  $<

clean:
	- rm -f $(PDFS) $(AUXS) $(LOGS) $(OUTS) $(TOCS) *~
	- rm -rf user_guide/ 
	- rm -f INPUT_*.html INPUT_*.txt INPUT_*.xml qe-input-ref.html

user_guide: user_guide.pdf
	 - rm -rf user_guide/
	 - latex2html \
                -t "User's Guide for Quantum-ESPRESSO" \
                -html_version 3.2,math \
                -toc_depth 5 -split 5 -toc_stars -show_section_numbers \
                -local_icons -image_type png \
                user_guide.tex
	if test -d user_guide; then \
		cd user_guide; \
	        for file in *.html; do \
	                cp $$file /tmp/$$file; \
	                cat /tmp/$$file | sed 's/HREF="http/NAME="http/g' | sed 's/mathend000#//g' - > $$file; \
	                rm -f /tmp/$$file; \
	        done; \
	fi
	@if test -d user_guide; then \
		echo ""; \
		echo "***"; \
		echo "*** User's Guide created in user_guide/user_guide.html"; \
		echo "***"; \
		echo ""; \
	fi

brillouin_zones: brillouin_zones.pdf

=== FFTXlib/CMakeLists.txt ===
###########################################################
# External FFT library that FFTXLIB depends on
# The following targets will be defined:
add_library(qe_ext_fft INTERFACE)
qe_install_targets(qe_ext_fft)
###########################################################
SET(BLA_VENDOR_SAVED ${BLA_VENDOR})
if(QE_FFTW_VENDOR STREQUAL "AUTO")
    # Try to find a FFTW library installed in the system
    find_package(VendorFFTW)
    if(VendorFFTW_FOUND)
        if(VendorFFTW_ID STREQUAL "Intel")
            qe_add_global_compile_definitions(__DFTI)
            set(qe_ext_fft_wrappers fft_scalar.DFTI.f90)
        elseif(VendorFFTW_ID STREQUAL "Arm")
            ## ARMPL implements the same interface of the standard FFTW
            ## no need of QE ARMPL wrapper
            #qe_add_global_compile_definitions(__ARM_LIB)
            #set(qe_ext_fft_wrappers fft_scalar.ARM_LIB.f90)
            qe_add_global_compile_definitions(__FFTW3)
            set(qe_ext_fft_wrappers fft_scalar.FFTW3.f90)
        elseif(VendorFFTW_ID STREQUAL "IBMESSL")
            qe_add_global_compile_definitions(__LINUX_ESSL)
            set(qe_ext_fft_wrappers fft_scalar.ESSL.f90)
        endif()
        target_link_libraries(qe_ext_fft INTERFACE VendorFFTW)
    else()
        # Try to find the official FFTW3
        if(QE_ENABLE_OPENMP)
            find_package(FFTW3 COMPONENTS DOUBLE_OPENMP DOUBLE)
        else()
            find_package(FFTW3 COMPONENTS DOUBLE)
        endif()
        if(FFTW3_FOUND)
            qe_add_global_compile_definitions(__FFTW3)
            set(qe_ext_fft_wrappers fft_scalar.FFTW3.f90)
            target_link_libraries(qe_ext_fft INTERFACE FFTW3)
        else()
            message(STATUS "CMake variable FFTW3_ROOT may be used to hint the root directory of FFTW3 installation.")
            # Cannot find anything useful, just point out internal FFTW fallback.
            message(FATAL_ERROR "Failed to find an external FFTW library. "
                                "Alternatively, '-DQE_FFTW_VENDOR=Internal' may be used to enable reference FFTW "
                                "at a performance loss compared to optimized libraries.")

        endif()
    endif()
elseif(QE_FFTW_VENDOR MATCHES "Intel")
    if(QE_FFTW_VENDOR STREQUAL "Intel_DFTI")
        qe_add_global_compile_definitions(__DFTI)
        set(qe_ext_fft_wrappers fft_scalar.DFTI.f90)
    elseif(QE_FFTW_VENDOR STREQUAL "Intel_FFTW3")
        qe_add_global_compile_definitions(__FFTW3)
        set(qe_ext_fft_wrappers fft_scalar.FFTW3.f90)
    else()
        message(FATAL_ERROR "The unknown Intel FFTW library '${QE_FFTW_VENDOR}' is not supported!")
    endif()
    if(QE_ENABLE_OPENMP)
        SET(BLA_VENDOR Intel10_64lp)
    else()
        SET(BLA_VENDOR Intel10_64lp_seq)
    endif()
    find_package(LAPACK QUIET)
    find_package(VendorFFTW REQUIRED COMPONENTS MKL)
    if(VendorFFTW_FOUND)
        target_link_libraries(qe_ext_fft INTERFACE VendorFFTW)
        message(STATUS "Found ${QE_FFTW_VENDOR} library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "ArmPL")
    if(QE_ENABLE_OPENMP)
        SET(BLA_VENDOR Arm_mp)
    else()
        SET(BLA_VENDOR Arm)
    endif()
    find_package(LAPACK QUIET)
    find_package(VendorFFTW REQUIRED COMPONENTS ArmPL)
    if(VendorFFTW_FOUND)
        qe_add_global_compile_definitions(__FFTW3)
        set(qe_ext_fft_wrappers fft_scalar.FFTW3.f90)
        target_link_libraries(qe_ext_fft INTERFACE VendorFFTW)
        message(STATUS "Found ${QE_FFTW_VENDOR} library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library installed in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "IBMESSL")
    SET(BLA_VENDOR IBMESSL)
    find_package(BLAS QUIET)
    find_package(VendorFFTW REQUIRED COMPONENTS IBMESSL)
    if(VendorFFTW_FOUND)
        qe_add_global_compile_definitions(__LINUX_ESSL)
        set(qe_ext_fft_wrappers fft_scalar.ESSL.f90)
        target_link_libraries(qe_ext_fft INTERFACE VendorFFTW)
        message(STATUS "Found ${QE_FFTW_VENDOR} library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library installed in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "FFTW3")
    if(QE_ENABLE_OPENMP)
        find_package(FFTW3 REQUIRED COMPONENTS DOUBLE_OPENMP DOUBLE)
    else()
        find_package(FFTW3 REQUIRED COMPONENTS DOUBLE)
    endif()
    if(FFTW3_FOUND)
        qe_add_global_compile_definitions(__FFTW3)
        set(qe_ext_fft_wrappers fft_scalar.FFTW3.f90)
        target_link_libraries(qe_ext_fft INTERFACE FFTW3)
        message(STATUS "Found FFTW3 library")
    else()
        message(FATAL_ERROR "Failed to find ${QE_FFTW_VENDOR} library. "
            "Alternatively, remove -DQE_FFTW_VENDOR to automatic search a FFTW library installed in the system.")
    endif()
elseif(QE_FFTW_VENDOR STREQUAL "Internal")
    message(STATUS "QE internal implementation of FFTW (FFTXLib)")
    qe_add_global_compile_definitions(__FFTW)
    set(qe_ext_fft_wrappers fft_scalar.FFTW.f90)
else()
    message(FATAL_ERROR "The FFTW vendor library '${QE_FFTW_VENDOR}' is not supported!")
endif()

SET(BLA_VENDOR ${BLA_VENDOR_SAVED})

add_subdirectory(src)

###########################################################
# Tests
# TODO move all tests to a proper location
###########################################################
if(QE_ENABLE_TEST)
    add_subdirectory(tests)
endif()

=== PP/Makefile ===
# Makefile for PostProc
sinclude ../make.inc

default: all

all:
	if test -d src ; then \
	( cd src ; $(MAKE) || exit 1 ) ; fi

doc:
	if test -d Doc ; then \
	(cd Doc ; $(MAKE) all || exit 1 ) ; fi

doc_clean:
	if test -d Doc ; then \
	(cd Doc ; $(MAKE) clean ) ; fi

clean : examples_clean
	if test -d src ; then \
	( cd src ; $(MAKE) clean ) ; fi

examples_clean:
	if test -d examples ; then \
	( cd examples ; ./clean_all ) ; fi

distclean: clean doc_clean

=== PW/CMakeLists.txt ===
set(src_pw
   src/a2fmod.f90 
   src/add_bfield.f90 
   src/add_efield.f90 
   src/add_dmft_occ.f90 
   src/add_vuspsi.f90 
   src/add_gatefield.f90 
   src/add_paw_to_deeq.f90 
   src/add_vhub_to_deeq.f90 
   src/addusdens.f90 
   src/addusforce.f90 
   src/addusstress.f90 
   src/allocate_fft.f90 
   src/allocate_locpot.f90 
   src/allocate_wfc.f90 
   src/atomic_rho.f90 
   src/atomic_wfc.f90 
   src/atomic_wfc_mod.f90 
   src/average_pp.f90 
   src/acfdt_in_pw.f90 
   src/newd.f90 
   src/beef.f90 
   src/bp_mod.f90 
   src/bp_c_phase.f90 
   src/bp_strings.f90 
   src/buffers.f90 
   src/c_bands.f90 
   src/c_phase_field.f90 
   src/orbm_kubo.f90 
   src/cdiagh.f90 
   src/clean_pw.f90 
   src/close_files.f90 
   src/commutator_Hx_psi.f90
   src/commutator_Vhubx_psi.f90
   src/compute_becsum.f90 
   src/compute_deff.f90 
   src/compute_dip.f90 
   src/compute_rho.f90 
   src/compute_qdipol.f90 
   src/compute_qdipol_so.f90 
   src/compute_ux.f90 
   src/coset.f90 
   src/Coul_cut_2D.f90 
   src/d_matrix.f90 
   src/data_structure.f90 
   src/divide_class.f90 
   src/divide_class_so.f90 
   src/divide_et_impera.f90 
   src/rotate_wfc.f90 
   src/run_driver.f90 
   src/dynamics_module.f90 
   src/efermig.f90 
   src/efermit.f90 
   src/electrons.f90
   src/environ_pw_module.f90 
   src/eqvect.f90 
   src/esm.f90 
   src/esm_common_mod.f90 
   src/esm_ewald_mod.f90 
   src/esm_force_mod.f90 
   src/esm_hartree_mod.f90 
   src/esm_local_mod.f90 
   src/esm_stres_mod.f90 
   src/ewald.f90 
   src/ewald_dipole.f90 
   src/extfield.f90 
   src/exx_base.f90 
   src/exx_band.f90 
   src/exx.f90 
   src/fcp_capacitance.f90 
   src/fcp_dyn_calcavg.f90 
   src/fcp_dyn_printavg.f90 
   src/fcp_dynamics.f90 
   src/fcp_hessian.f90 
   src/fcp_input.f90 
   src/fcp_module.f90 
   src/fcp_relaxation.f90 
   src/find_group.f90 
   src/forces_bp_efield.f90 
   src/force_cc.f90 
   src/force_corr.f90 
   src/force_ew.f90 
   src/force_hub.f90 
   src/force_lc.f90 
   src/force_us.f90 
   src/forces.f90 
   src/g_psi.f90 
   src/g_psi_mod.f90 
   src/gcscf_input.f90 
   src/gcscf_module.f90 
   src/gen_at_dj.f90 
   src/gen_at_dy.f90 
   src/get_locals.f90 
   src/gk_sort.f90 
   src/gradcorr.f90 
   src/gweights.f90 
   src/g2_kin.f90 
   src/hs_psi.f90 
   src/hs_1psi.f90 
   src/h_epsi_her_apply.f90 
   src/h_epsi_her_set.f90 
   src/h_psi.f90 
   src/h_psi_meta.f90 
   src/hinit0.f90 
   src/hinit1.f90 
   src/hubbard.f90 
   src/init_ns.f90 
   src/init_q_aeps.f90 
   src/init_run.f90 
   src/init_us_2.f90 
   src/init_vloc.f90 
   src/input.f90 
   src/io_rho_xml.f90 
   src/irrek.f90 
   src/iweights.f90 
   src/intersite_V.f90 
   src/init_nsg.f90 
   src/nsg_adj.f90 
   src/start_k.f90 
   src/kpoint_grid.f90 
   src/lchk_tauxk.f90 
   src/ldaU.f90 
   src/make_pointlists.f90 
   src/manypw.f90 
   src/martyna_tuckerman.f90 
   src/memory_report.f90 
   src/mix_rho.f90 
   src/move_ions.f90 
   src/multable.f90 
   src/n_plane_waves.f90 
   src/new_ns.f90 
   src/new_nsb.f90 
   src/new_nsg.f90 
   src/new_occ.f90 
   src/ns_adj.f90 
   src/non_scf.f90 
   src/offset_atom_wfc.f90 
   src/openfil.f90 
   src/orthoatwfc.f90 
   src/output_tau.f90 
   src/para.f90 
   src/paw_exx.f90 
   src/paw_init.f90 
   src/paw_onecenter.f90 
   src/paw_symmetry.f90 
   src/plugin_print_energies.f90 
   src/plugin_scf_energy.f90 
   src/plugin_scf_potential.f90 
   src/plugin_init_ions.f90 
   src/plugin_init_cell.f90 
   src/plugin_init_potential.f90 
   src/plugin_initbase.f90 
   src/plugin_clean.f90 
   src/plugin_check.f90 
   src/plugin_clock.f90 
   src/plugin_summary.f90 
   src/plugin_initialization.f90 
   src/plugin_ext_forces.f90 
   src/plugin_int_forces.f90 
   src/plugin_read_input.f90 
   src/plus_u_full.f90 
   src/potinit.f90 
   src/print_clock_pw.f90 
   src/print_ks_energies.f90 
   src/punch.f90 
   src/pw_restart_new.f90 
   src/add_qexsd_step.f90 
   src/pw_init_qexsd_input.f90 
   src/pwcom.f90 
   src/pw2blip.f90 
   src/pw2casino.f90 
   src/pw2casino_write.f90 
   src/rdiagh.f90 
   src/read_conf_from_file.f90 
   src/read_file_new.f90 
   src/realus.f90 
   src/remove_atomic_rho.f90
   src/report_mag.f90 
   src/restart_in_electrons.f90 
   src/rho2zeta.f90 
   src/rism_module.f90 
   src/ruotaijk.f90 
   src/run_pwscf.f90 
   src/s_1psi.f90 
   src/s_psi.f90 
   src/s_psi_acc.f90 
   src/save_in_cbands.f90 
   src/save_in_electrons.f90 
   src/scale_h.f90 
   src/loc_scdm.f90 
   src/loc_scdm_k.f90 
   src/scf_mod.f90 
   src/set_kplusq.f90 
   src/set_kup_and_kdw.f90 
   src/set_occupations.f90 
   src/set_rhoc.f90 
   src/set_spin_vars.f90 
   src/set_vrs.f90 
   src/setlocal.f90 
   src/setup.f90 
   src/starting_scf_mod.f90
   src/stop_run.f90 
   src/stres_cc.f90 
   src/stres_ewa.f90 
   src/stres_gradcorr.f90 
   src/stres_har.f90 
   src/stres_hub.f90 
   src/stres_knl.f90 
   src/stres_loc.f90 
   src/stres_us.f90 
   src/stres_nonloc_dft.f90 
   src/stres_mgga.f90 
   src/stress.f90 
   src/struct_fact.f90 
   src/sum_band.f90 
   src/sumkg.f90 
   src/sumkt.f90 
   src/summary.f90 
   src/symme.f90 
   src/symm_base.f90 
   src/symmetrize_at.f90 
   src/tetra.f90 
   src/transform_becsum_so.f90 
   src/transform_becsum_nc.f90 
   src/trnvecc.f90 
   src/two_chem.f90
   src/update_pot.f90 
   src/us_exx.f90 
   src/usnldiag.f90 
   src/v_of_rho.f90 
   src/vcsmd.f90 
   src/vcsubs.f90 
   src/vhpsi.f90 
   src/vloc_psi.f90 
   src/utils.f90 
   src/xdm_dispersion.f90 
   src/wfcinit.f90 
   src/write_ns.f90 
   src/wsweight.f90 
   src/weights.f90 
   src/ortho_wfc.f90 
   src/wannier_init.f90 
   src/wannier_check.f90 
   src/wannier_clean.f90 
   src/wannier_occ.f90
   src/d3hess_mod.f90
   # GPU
   src/g_psi_mod_gpu.f90
   src/newd_gpu.f90
   src/add_paw_to_deeq_gpu.f90
   src/rotate_wfc_gpu.f90
   src/usnldiag_gpu.f90
   src/add_vuspsi_gpu.f90
   src/hs_1psi_gpu.f90
   src/g_psi_gpu.f90
   src/add_vhub_to_deeq_gpu.f90
   src/s_1psi_gpu.f90
   src/h_psi_gpu.f90
   src/utils_gpu.f90
   src/vhpsi_gpu.f90
   src/vloc_psi_gpu.f90
   src/hs_psi_gpu.f90
   src/sic.f90
   src/scissor.f90)
# OSCDFT
if (QE_ENABLE_OSCDFT)
    list(APPEND src_pw
        src/oscdft_input.f90
        src/oscdft_context.f90
        src/oscdft_base.f90
        src/oscdft_enums.f90
        src/oscdft_indices.f90
        src/oscdft_wavefunction.f90
        src/oscdft_wavefunction_subs.f90
        src/oscdft_functions.f90
        src/oscdft_occupations.f90
        src/oscdft_wfcO.f90
        src/oscdft_forces.f90
        src/oscdft_forces_subs.f90
        # GPU
        src/oscdft_functions_gpu.f90)
endif()
qe_enable_cuda_fortran("${src_pw}")
    
qe_add_library(qe_pw ${src_pw})
target_link_libraries(qe_pw
    PRIVATE
        qe_device_lapack  
        qe_hdf5_fortran
        qe_elpa
        qe_scalapack
        qe_lax
        qe_kssolver_davidson
        qe_kssolver_cg
        qe_kssolver_ppcg
        qe_kssolver_paro
        qe_kssolver_rmmdiis
        qe_kssolver_dense
        qe_upflib # TODO turn to vendorized library from MaX gitrepo ? 
        qe_modules
        qe_fftx
        qe_dftd3
        qe_openmp_fortran
        qe_mpi_fortran
        qe_xclib
        qe_devxlib
        qe_mbd
    PUBLIC
        qe_openacc_fortran)

if(QE_ENABLE_CUDA)
    target_link_libraries(qe_pw
        PRIVATE
            CUDA::cublas)
endif()
if ("legacy" IN_LIST QE_ENABLE_PLUGINS) 
  target_compile_definitions(qe_pw PUBLIC __LEGACY_PLUGINS)
endif()

###########################################################
# pw.x
###########################################################
set(src_pw_x src/pwscf.f90)
qe_enable_cuda_fortran("${src_pw_x}")
qe_add_executable(qe_pw_exe ${src_pw_x})
set_target_properties(qe_pw_exe 
    PROPERTIES 
        OUTPUT_NAME pw.x)
target_link_libraries(qe_pw_exe
    PRIVATE
        qe_pw
        qe_modules
        qe_lax
        qe_upflib)

###########################################################
# ibrav2cell.x
###########################################################
set(src_ibrav2cell_X tools/ibrav2cell.f90)
qe_add_executable(qe_pw_tools_ibrav2cell_exe ${src_ibrav2cell_X})
set_target_properties(qe_pw_tools_ibrav2cell_exe 
    PROPERTIES 
        OUTPUT_NAME ibrav2cell.x)
target_link_libraries(qe_pw_tools_ibrav2cell_exe
    PRIVATE
        qe_pw
        qe_modules)

###########################################################
# cell2ibrav.x
###########################################################
set(src_cell2ibrav_x tools/cell2ibrav.f90)
qe_add_executable(qe_pw_tools_cell2ibrav_exe ${src_cell2ibrav_x})
set_target_properties(qe_pw_tools_cell2ibrav_exe 
    PROPERTIES 
        OUTPUT_NAME cell2ibrav.x)
target_link_libraries(qe_pw_tools_cell2ibrav_exe
    PRIVATE
        qe_pw
        qe_modules)

###########################################################
# ev.x
###########################################################
set(src_ev_x tools/ev.f90)
qe_add_executable(qe_pw_tools_ev_exe ${src_ev_x})
set_target_properties(qe_pw_tools_ev_exe 
    PROPERTIES 
        OUTPUT_NAME ev.x)
target_link_libraries(qe_pw_tools_ev_exe
    PRIVATE
        qe_pw
        qe_modules)

###########################################################
# kpoints.x
###########################################################
set(src_kpoints_x tools/kpoints.f90)
qe_add_executable(qe_pw_tools_kpoints_exe ${src_kpoints_x})
set_target_properties(qe_pw_tools_kpoints_exe 
    PROPERTIES 
        OUTPUT_NAME kpoints.x)
target_link_libraries(qe_pw_tools_kpoints_exe
    PRIVATE
        qe_pw
        qe_modules)

###########################################################
# pwi2xsf.x
###########################################################
set(src_pwi2xsf_x tools/pwi2xsf.f90)
qe_add_executable(qe_pw_tools_pwi2xsf_exe ${src_pwi2xsf_x})
set_target_properties(qe_pw_tools_pwi2xsf_exe 
    PROPERTIES 
        OUTPUT_NAME pwi2xsf.x)
target_link_libraries(qe_pw_tools_pwi2xsf_exe
    PRIVATE
        qe_pw
        qe_modules)

###########################################################
# scan_ibrav.x
###########################################################
set(src_scan_ibrav_x tools/scan_ibrav.f90)
qe_add_executable(qe_pw_tools_scan_ibrav_exe ${src_scan_ibrav_x})
set_target_properties(qe_pw_tools_scan_ibrav_exe
    PROPERTIES
        OUTPUT_NAME scan_ibrav.x)
target_link_libraries(qe_pw_tools_scan_ibrav_exe
    PRIVATE
        qe_pw
        qe_modules)

###########################################################

set(PW_EXE_TARGETS
    qe_pw_exe
    qe_pw_tools_ibrav2cell_exe
    qe_pw_tools_cell2ibrav_exe
    qe_pw_tools_ev_exe
    qe_pw_tools_kpoints_exe
    qe_pw_tools_pwi2xsf_exe
    qe_pw_tools_scan_ibrav_exe)

qe_install_targets(
    # Libraries
    qe_pw
    # Executables
    ${PW_EXE_TARGETS})

add_custom_target(pw
    DEPENDS
        ${PW_EXE_TARGETS}
    COMMENT
        "basic code for scf, structure optimization, MD")

=== dft-d3/CMakeLists.txt ===
set(src_dftd3
    common.f90
    sizes.f90
    pars.f90
    core.f90
    api.f90
    dftd3_qe.f90)

qe_add_library(qe_dftd3 ${src_dftd3})
target_link_libraries(qe_dftd3
    PUBLIC
        qe_openacc_fortran
    PRIVATE
        qe_modules
        qe_upflib)

###########################################################
# test.x
###########################################################
if(QE_ENABLE_TEST)
    set(src_dftd3_test test_code.f90)
    qe_add_executable(qe_atomic_test_exe ${src_dftd3_test})
    set_target_properties(qe_atomic_test_exe 
        PROPERTIES 
            OUTPUT_NAME qe_dftd3_test_atomic.x 
            RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
    target_link_libraries(qe_atomic_test_exe
        PRIVATE
            qe_modules
            qe_dftd3)
    # FIXME: Does it work?
    #add_test(NAME test_qe_dftd3_atomic COMMAND $<TARGET_FILE:qe_atomic_test_exe>)
endif()

qe_install_targets(qe_dftd3)

=== GWW/pw4gww/Makefile ===
# Makefile for pw4gww (PW4GWW)
# Author G. Stenuit and L. Martin-Samos
# Modified Joshua Elliott November 2020 as JDE

include ../../make.inc

# location of needed modules
MODFLAGS= $(BASEMOD_FLAGS) \
          $(MOD_FLAG)../../PW/src

PW4GWWOBJS = \
allocate_wannier.o \
produce_wannier_gamma.o \
start_pw4gww.o \
stop_pp.o \
openfil_pw4gww.o \
dft_exchange.o  \
wfc_real.o \
full.o \
energies_xc.o  \
wannier.o  \
write_wannier_matrix.o  \
rotate_wannier.o  \
self_lanczos.o \
pola_lanczos.o \
matrix_wannier_gamma.o \
calculate_wing.o  \
fake_conduction.o \
o_1psi.o  \
o_bands.o  \
optimal.o \
pola_partial.o \
semicore.o \
semicore_read.o \
v_basis.o  \
wannier_uterms.o \
write_vpot_matrix.o  \
diago_cg.o  \
o_rinitcgg.o \
diago_cg_g.o \
contour_terms.o \
fft_custom.o  \
exchange_custom.o \
mp_wave_parallel.o \
wannier_bse.o\
hpsi_pw4gww.o \
cgsolve_all_gamma.o \
gww_realus.o \
operator_1_vp.o \
operator_debug.o \
lanczos_chains.o \
convergence.o \
easy_gw.o

QEMODS = $(BASEMODS)
PWOBJS = ../../PW/src/libpw.a ../../KS_Solvers/libks_solvers.a ../../dft-d3/libdftd3qe.a
PHOBJS = ../../PHonon/Gamma/libphcg.a ../../LR_Modules/liblrmod.a 

TLDEPS= phlibs 

all : tldeps pw4gww.x

pw4gww.x : pw4gww.o libpw4gww.a  $(PW4GWWOBJS) $(PWOBJS) $(QEMODS)
	$(LD) $(LDFLAGS) -o $@ \
	pw4gww.o libpw4gww.a $(PHOBJS) $(PWOBJS) $(QEMODS) $(QELIBS) 
	- ( cd ../../bin ; ln -fs ../GWW/pw4gww/$@ . )

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../.. ; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

libpw4gww.a : $(PW4GWWOBJS)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

clean :
	- /bin/rm -f *.x *.o *~ *_tmp.f90 *.d *.mod *.i *.L libpw4gww.a

include make.depend
# DO NOT DELETE

=== PP/Doc/Makefile ===
VERSION := $(shell awk -F\' '/version_number/{print $$2}' ../../include/qe_version.h )
HELPDOC = ../../dev-tools/helpdoc -version $(VERSION)
LATEX   = pdflatex
LATEX2HTML = latex2html


HTMLS = INPUT_BAND_INTERPOLATION.html \
	INPUT_BANDS.html \
	INPUT_bgw2pw.html \
	INPUT_D3HESS.html \
	INPUT_DOS.html \
	INPUT_molecularpdos.html \
	INPUT_OSCDFT_ET.html \
	INPUT_OSCDFT_PP.html \
	INPUT_PPACF.html \
	INPUT_PP.html \
	INPUT_PPRISM.html \
	INPUT_PROJWFC.html \
	INPUT_pw2bgw.html \
	INPUT_pw2gw.html \
	INPUT_pw2wannier90.html

PDFS = eps_man.pdf user_guide.pdf
AUXS = $(PDFS:.pdf=.aux)
LOGS = $(PDFS:.pdf=.log)
OUTS = $(PDFS:.pdf=.out)
TOCS = $(PDFS:.pdf=.toc)

XMLS = $(HTMLS:.html=.xml)
TXTS = $(HTMLS:.html=.txt)

doc: all
all: defs pdf html
pdf: $(PDFS)
html: user_guide

$(PDFS): %.pdf: %.tex
	$(LATEX)  $<
	$(LATEX)  $<

defs: input_xx.xsl $(HTMLS) link_on_main_doc

$(HTMLS): %.html: %.def input_xx.xsl
	$(HELPDOC) $<

$(TXTS): %.txt: %.def input_xx.xsl
	$(HELPDOC) $<

input_xx.xsl:
	@(if test ! -f input_xx.xsl; then \
	(if test -f ../../dev-tools/input_xx.xsl; then \
        (ln -sf ../../dev-tools/input_xx.xsl input_xx.xsl) ; \
        else \
        echo ; \
        echo "  Sorry, can not find input_xx.xsl html style file !!!" ; \
        echo ; exit 1 ; \
        fi) ; fi)

link_on_main_doc:
	-@( cd ../../Doc ; for file in $(HTMLS) $(XMLS) $(TXTS); do ln -fs ../PP/Doc/$$file . ; done )

user_guide: user_guide.pdf
	- rm -rf user_guide/
	latex2html \
		-t "User's Guide for the PP package" \
                -html_version 3.2,math \
                -toc_depth 5 -split 5 -toc_stars -show_section_numbers \
                -local_icons -image_type png \
                user_guide.tex
	cd user_guide; \
	for file in *.html; do \
		cp $$file /tmp/$$file; \
		cat /tmp/$$file | sed 's/HREF="http/NAME="http/g' | sed 's/mathend000#//g' - > $$file; \
		rm -f /tmp/$$file; \
	done
	@echo ""
	@echo "***"
	@echo "*** User's Guide created in user_guide/user_guide.html"
	@echo "***"
	@echo ""

clean:
	- rm -f $(PDFS) $(AUXS) $(LOGS) $(OUTS) $(TOCS)
	- rm -f $(HTMLS) $(TXTS) $(XMLS) input_xx.xsl *~
	- rm -f $(patsubst %,../../Doc/%,$(HTMLS) $(XMLS) $(TXTS))

=== PW/src/Makefile ===
# Makefile for PW

include ../../make.inc

# location of needed modules and included files (if any)
MODFLAGS= $(BASEMOD_FLAGS) \
          $(MOD_FLAG)../../dft-d3/

PWOBJS = \
pwscf.o 

PWLIBS = \
a2fmod.o \
add_bfield.o \
add_efield.o \
add_dmft_occ.o \
add_vuspsi.o \
add_gatefield.o \
add_paw_to_deeq.o \
add_vhub_to_deeq.o \
addusdens.o \
addusforce.o \
addusstress.o \
allocate_fft.o \
allocate_locpot.o \
allocate_wfc.o \
atomic_rho.o \
atomic_wfc.o \
atomic_wfc_mod.o \
average_pp.o \
acfdt_in_pw.o \
newd.o \
beef.o \
bp_mod.o \
bp_c_phase.o \
bp_strings.o \
buffers.o \
c_bands.o \
c_phase_field.o \
orbm_kubo.o \
cdiagh.o \
clean_pw.o \
close_files.o \
commutator_Hx_psi.o \
commutator_Vhubx_psi.o \
compute_becsum.o \
compute_deff.o \
compute_dip.o \
compute_rho.o \
compute_qdipol.o \
compute_qdipol_so.o \
compute_ux.o \
coset.o \
Coul_cut_2D.o \
d_matrix.o \
data_structure.o \
divide_class.o \
divide_class_so.o \
divide_et_impera.o \
rotate_wfc.o \
run_driver.o \
dynamics_module.o \
efermig.o \
efermit.o \
electrons.o \
environ_pw_module.o \
eqvect.o \
esm.o \
esm_common_mod.o \
esm_ewald_mod.o \
esm_force_mod.o \
esm_hartree_mod.o \
esm_local_mod.o \
esm_stres_mod.o \
ewald.o \
ewald_dipole.o \
extfield.o \
exx_base.o \
exx_band.o \
exx.o \
fcp_capacitance.o \
fcp_dyn_calcavg.o \
fcp_dyn_printavg.o \
fcp_dynamics.o \
fcp_hessian.o \
fcp_input.o \
fcp_module.o \
fcp_relaxation.o \
find_group.o \
forces_bp_efield.o \
force_cc.o \
force_corr.o \
force_ew.o \
force_hub.o \
force_lc.o \
force_us.o \
forces.o \
g_psi.o \
g_psi_mod.o \
gcscf_input.o \
gcscf_module.o \
gen_at_dj.o \
gen_at_dy.o \
get_locals.o \
gk_sort.o \
gradcorr.o \
gweights.o \
g2_kin.o \
hs_psi.o \
hs_1psi.o \
h_epsi_her_apply.o \
h_epsi_her_set.o \
h_psi.o \
h_psi_meta.o \
hinit0.o \
hinit1.o \
hubbard.o \
init_ns.o \
init_q_aeps.o \
init_run.o \
init_us_2.o \
init_vloc.o \
input.o \
io_rho_xml.o \
irrek.o \
iweights.o \
intersite_V.o \
init_nsg.o \
nsg_adj.o \
start_k.o \
kpoint_grid.o \
lchk_tauxk.o \
ldaU.o \
make_pointlists.o \
manypw.o \
martyna_tuckerman.o \
memory_report.o \
mix_rho.o \
move_ions.o \
multable.o \
n_plane_waves.o \
new_ns.o \
new_nsb.o \
new_nsg.o \
new_occ.o \
ns_adj.o \
non_scf.o \
offset_atom_wfc.o \
openfil.o \
orthoatwfc.o \
output_tau.o \
para.o \
paw_exx.o \
paw_init.o \
paw_onecenter.o \
paw_symmetry.o \
plugin_print_energies.o \
plugin_scf_energy.o \
plugin_scf_potential.o \
plugin_init_ions.o \
plugin_init_cell.o \
plugin_init_potential.o \
plugin_initbase.o \
plugin_clean.o \
plugin_check.o \
plugin_clock.o \
plugin_summary.o \
plugin_initialization.o \
plugin_ext_forces.o \
plugin_int_forces.o \
plugin_read_input.o \
plus_u_full.o \
potinit.o \
print_clock_pw.o \
print_ks_energies.o \
punch.o \
pw_restart_new.o \
add_qexsd_step.o \
pw_init_qexsd_input.o \
pwcom.o \
pw2blip.o \
pw2casino.o \
pw2casino_write.o \
rdiagh.o \
read_conf_from_file.o \
read_file_new.o \
realus.o \
remove_atomic_rho.o \
report_mag.o \
restart_in_electrons.o \
rho2zeta.o \
rism_module.o \
ruotaijk.o \
run_pwscf.o \
s_1psi.o \
s_psi.o \
s_psi_acc.o \
save_in_cbands.o \
save_in_electrons.o \
scale_h.o \
loc_scdm.o \
loc_scdm_k.o \
scf_mod.o \
set_kplusq.o \
set_kup_and_kdw.o \
set_occupations.o \
set_rhoc.o \
set_spin_vars.o \
set_vrs.o \
setlocal.o \
setup.o \
scissor.o \
sic.o \
starting_scf_mod.o \
stop_run.o \
stres_cc.o \
stres_ewa.o \
stres_gradcorr.o \
stres_har.o \
stres_hub.o \
stres_knl.o \
stres_loc.o \
stres_us.o \
stres_nonloc_dft.o \
stres_mgga.o \
stress.o \
struct_fact.o \
sum_band.o \
sumkg.o \
sumkt.o \
summary.o \
symme.o \
symm_base.o \
symmetrize_at.o \
tetra.o \
transform_becsum_so.o \
transform_becsum_nc.o \
trnvecc.o \
two_chem.o\
update_pot.o \
us_exx.o \
usnldiag.o \
v_of_rho.o \
vcsmd.o \
vcsubs.o \
vhpsi.o \
vloc_psi.o \
utils.o \
xdm_dispersion.o \
wfcinit.o \
write_ns.o \
wsweight.o \
weights.o \
ortho_wfc.o \
wannier_init.o \
wannier_check.o \
wannier_clean.o \
wannier_occ.o \
oscdft_input.o \
oscdft_context.o \
oscdft_base.o \
oscdft_enums.o \
oscdft_indices.o \
oscdft_wavefunction.o \
oscdft_wavefunction_subs.o \
oscdft_functions.o \
oscdft_occupations.o \
oscdft_wfcO.o \
oscdft_forces.o \
oscdft_forces_subs.o \
d3hess_mod.o


# GPU versions of routines
PWLIBS += \
  g_psi_mod_gpu.o \
  g_psi_gpu.o \
  h_psi_gpu.o \
  vhpsi_gpu.o \
  vloc_psi_gpu.o \
  usnldiag_gpu.o \
  add_vuspsi_gpu.o \
  newd_gpu.o \
  add_paw_to_deeq_gpu.o \
  add_vhub_to_deeq_gpu.o \
  rotate_wfc_gpu.o \
  hs_1psi_gpu.o \
  hs_psi_gpu.o \
  s_1psi_gpu.o \
  utils_gpu.o \
  oscdft_functions_gpu.o



QEMODS=../../KS_Solvers/libks_solvers.a ../../dft-d3/libdftd3qe.a $(BASEMODS)

TLDEPS= bindir pwlibs mods libks_solvers dftd3

all : tldeps pw.x

pw.x : $(PWOBJS) libpw.a $(QEMODS)
	$(LD) $(LDFLAGS) -o $@ \
	   $(PWOBJS) libpw.a $(QEMODS) $(QELIBS)
	- ( cd ../../bin; ln -fs ../PW/src/$@ . ; \
               ln -fs ../PW/src/$@ dist.x ; ln -fs ../PW/src/$@ manypw.x ; )
# dist.x and manypw.x link the same executable pw.x

libpw.a : $(PWLIBS) 
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@

tldeps :
	if test -n "$(TLDEPS)" ; then \
	( cd ../.. ; $(MAKE) $(TLDEPS) || exit 1 ) ; fi

clean :
	- /bin/rm -f *.x *.o *.a *~ *_tmp.f90 *.d *.mod *.i *.L

include make.depend

# DO NOT DELETE

=== XSpectra/src/Makefile ===
# Makefile for X-ray spectra calculation (XSPECTRA)

include ../../make.inc

# location of needed modules and included files (if any)
MODFLAGS= $(BASEMOD_FLAGS) \
          $(MOD_FLAG)../../PW/src \
          $(MOD_FLAG)../../dft-d3

XOBJS = \
./gaunt_mod.o \
./xspectra_mod.o \
./xspectra_utils.o \
./radin_mod.o \
./mygetK.o \
./ipoolscatter.o \
./lr_sm1_psi.o \
./read_k_points.o \
./reset_k_points_and_reinit.o \
./select_nl_init.o \
./lanczos.o \
./plot_xanes_cross_sections.o \
./xanes_dipole_general_edge.o\
./banner_xspectra.o \
./set_xspectra_namelists_defaults.o \
./read_input_and_bcast.o \
./stdout_routines.o \
./xanes_dipole.o \
./check_orthogonality_k_epsilon.o \
./assign_paw_radii_to_species.o \
./io_routines.o \
./xanes_quadrupole.o 

GIPAWOBJS=./paw_gipaw.o \
./init_gipaw_1.o \
./init_gipaw_2.o

MANIP_XS_OBJ=./gaunt_mod.o 
             
QEMODS = $(BASEMODS)
PWOBJS = ../../PW/src/libpw.a ../../KS_Solvers/libks_solvers.a ../../dft-d3/libdftd3qe.a

TLDEPS = pwlibs

all : tldeps xspectra.x spectra_correction.x molecularnexafs.x

xspectra.x :   xspectra.o $(XOBJS) $(GIPAWOBJS) $(QEMODS) $(PWOBJS)
	$(MPIF90) -o $@  xspectra.o $(XOBJS) $(GIPAWOBJS) \
		$(PWOBJS) $(QEMODS) $(LDFLAGS)  $(QELIBS)
	- ( cd ../../bin ; ln -fs ../XSpectra/src/$@ . )

spectra_correction.x : spectra_correction.o $(MANIP_XS_OBJ) $(QEMODS) $(PWOBJS)
	$(MPIF90) -o $@  spectra_correction.o $(MANIP_XS_OBJ) $(PWOBJS) $(QEMODS) \
                $(LDFLAGS)  $(QELIBS)
	- ( cd ../../bin ; ln -fs ../XSpectra/src/$@ . )

molecularnexafs.x : molecularnexafs.o 
	$(MPIF90) -o $@  molecularnexafs.o $(LDFLAGS)
	- ( cd ../../bin ; ln -fs ../XSpectra/src/$@ . )

tldeps : 
	test -n "$(TLDEPS)" && ( cd ../.. ; $(MAKE) $(MFLAGS) $(TLDEPS) || exit 1) || :

clean :
	- /bin/rm -f *.x *.o *~ *_tmp.f90 *.d *.mod *.i *.L
	- /bin/rm -f ../../bin/xspectra.x

include make.depend
# DO NOT DELETE

=== GUI/PWgui/doc/Makefile ===
TOPDIR        = ../../..

default: input_html qe_user_guide_html
all:     input_html compile_qe_user_guide qe_user_guide_html

# The difference between "default" and "all" targets:
# ---------------------------------------------------
#
# default = create QE html user-guide only if $(TOPDIR)/Doc/user_guide exists
#
# all     = create QE html user-guide (always)
#
# QE html user-guide is created in ./user_guide (to be used by PWgui),
# it is a slightly altered version of $(TOPDIR)/Doc/user_guide


input_html:
	./htmlise.sh $(TOPDIR)/PW/Doc/INPUT_PW.txt      > INPUT_PW.html
	./htmlise.sh $(TOPDIR)/NEB/Doc/INPUT_NEB.txt    > INPUT_NEB.html
	./htmlise.sh $(TOPDIR)/PHonon/Doc/INPUT_PH.txt  > INPUT_PH.html
	./htmlise.sh $(TOPDIR)/PP/Doc/INPUT_PP.txt      > INPUT_PP.html
	./htmlise.sh $(TOPDIR)/PP/Doc/INPUT_PROJWFC.txt > INPUT_PROJWFC.html
	./htmlise.sh $(TOPDIR)/PP/Doc/INPUT_BANDS.txt   > INPUT_BANDS.html
	./htmlise.sh $(TOPDIR)/PP/Doc/INPUT_DOS.txt     > INPUT_DOS.html
	./htmlise.sh $(TOPDIR)/atomic/Doc/INPUT_LD1.txt > INPUT_LD1.html
	./htmlise.sh $(TOPDIR)/HP/Doc/INPUT_HP.txt      > INPUT_HP.html

compile_qe_user_guide:
	-( cd $(TOPDIR)/Doc; $(MAKE) user_guide )

qe_user_guide_html: 
	-if test -d $(TOPDIR)/Doc/user_guide; then \
		rm -rf user_guide/; \
		cp -a $(TOPDIR)/Doc/user_guide .; \
		cd user_guide/; \
		for file in *.html; do \
			cp $$file /tmp/$$file; \
			cat /tmp/$$file | sed 's/&nbsp;/ /g' - > $$file; \
			rm -f /tmp/$$file; \
		done; \
	fi

clean: 
	-rm -f *html *~
	-rm -rf user_guide/	

distclean: clean
veryclean: clean

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=quantum-espresso
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=7.4.1
pkgrel=1
#_d3q_commit=de4718351e7bbb9d1d12aad2b7ca232d06775b83
_devxlib_commit=a6b89ef77b1ceda48e967921f1f5488d2df9226d
_fox_commit=3453648e6837658b747b895bb7bef4b1ed2eac40
_pw2qmcpack_commit=f72ab25fa4ea755c1b4b230ae8074b47d5509c70
#_qe_gipaw_commit=490046d300ec23444504bfad0562baa1c71f9345
pkgdesc="opEn-Source Package for Research in Electronic Structure, Simulation, and Optimization (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='http://www.quantum-espresso.org/'
msys2_repository_url="https://gitlab.com/QEF/q-e"
msys2_references=(
  'aur: quantum-espresso'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libmbd"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-wannier90"
             #"${MINGW_PACKAGE_PREFIX}-environ"
             "git")
source=("https://gitlab.com/QEF/q-e/-/archive/qe-${pkgver}/q-e-qe-${pkgver}.tar.bz2"
        #"d3q::git+https://github.com/anharmonic/d3q#commit=${_d3q_commit}"
        "devxlib::git+https://gitlab.com/max-centre/components/devicexlib#commit=${_devxlib_commit}"
        "fox::git+https://github.com/pietrodelugas/fox#commit=${_fox_commit}"
        "pw2qmcpack::git+https://github.com/QMCPACK/pw2qmcpack#commit=${_pw2qmcpack_commit}"
        #"qe-gipaw::git+https://github.com/dceresoli/qe-gipaw#commit=${_qe_gipaw_commit}"
        "001-use-srand-instead-of-srandom.patch"
        "002-fix-build-devxlib-on-mingw.patch"
        "003-fix-install-c-libraries.patch"
        "004-fix-executable-suffix-on-mingw.patch")
sha256sums=('151d0ed775dad1248ccb23518b9f1aa9d68e4ecc242a54ac8dfcb28ec618057d'
            'ef02c13a1ea73f38f0b81edd281c991c25bf045307ceb305f5c0f96b743d1556'
            '8625181b53f2b616a0f704507b4f2381f7b9fabe02078dfb74ab41ee11f5c260'
            'f0f5ebece3f0142e0d0b476db9547d8501de80259bc6409e9b108b887e4cc058'
            '2e18a13c194328516176c2bc2429ac230c9fc585381aa238e586b6034a7df0cb'
            'faaf147678e0c79a6678c5463dd5a466769257968275ef562f40ad1a0c2aacc6'
            'c889430a51d7b910723728c40ca73f183a93db58b1d03b02c6d7c98aea481e8b'
            '918cd94d6c770c88f59836ab4aedde749ac5e78da850556ad1a7acbf99109537')
noextract=("q-e-qe-${pkgver}.tar.bz2")

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  echo "Extracting q-e-qe-${pkgver}.tar.bz2..."
  tar -xjf q-e-qe-${pkgver}.tar.bz2 || true

  for _ext_prj in devxlib fox pw2qmcpack; do
    mv ${_ext_prj} q-e-qe-${pkgver}/external/
  done

  cd "${srcdir}"/q-e-qe-${pkgver}
  apply_patch_with_msg \
    001-use-srand-instead-of-srandom.patch \
    002-fix-build-devxlib-on-mingw.patch \
    003-fix-install-c-libraries.patch \
    004-fix-executable-suffix-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS=" -Wno-missing-include-dirs -w"
  fi

  CFLAGS+=" -Wno-incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DQE_ENABLE_FOX=ON \
      -DQE_ENABLE_HDF5=ON \
      -DQE_ENABLE_OPENMP=ON \
      -DQE_ENABLE_ENVIRON=OFF \
      -DQE_ENABLE_LIBXC=OFF \
      -DQE_ENABLE_MPI=OFF \
      -DQE_ENABLE_TEST=OFF \
      -DQE_ENABLE_PLUGINS="pw2qmcpack;legacy" \
      -DQE_DEVICEXLIB_INTERNAL=ON \
      -DQE_FOX_INTERNAL=ON \
      -DQE_MBD_INTERNAL=OFF \
      -DQE_WANNIER90_INTERNAL=OFF \
      -DQE_FFTW_VENDOR="FFTW3" \
      -DBLA_VENDOR=OpenBLAS \
      -S q-e-qe-${pkgver} \
      -B build-${MSYSTEM}

  "${MINGW_PREFIX}"/bin/cmake.exe --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/q-e-qe-${pkgver}/License \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/qe/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Rename cp to qe_cp, to not be used instead of /usr/bin/cp to copy files
  mv "${pkgdir}${MINGW_PREFIX}"/bin/{cp,qe_cp}.exe
}
